################################################################################
#                                                                              #
#                        Copyright (C) 2017 Kobra                              #
#                                                                              #
#  This Program is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by        #
#  the Free Software Foundation; either version 2, or (at your option)         #
#  any later version.                                                          #
#                                                                              #
#  This Program is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of              #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                #
#  GNU General Public License for more details.                                #
#                                                                              #
#  You should have received a copy of the GNU General Public License           #
#  along with XBMC; see the file COPYING.  If not, write to                    #
#  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.       #
#  http://www.gnu.org/copyleft/gpl.html                                        #
#                                                                              #
################################################################################

import os
import platform
import re
import sys
import subprocess
import shutil
import time
import urllib2, urllib
import xbmc, xbmcplugin, xbmcgui, xbmcaddon, xbmcvfs
from resources.libs import checkPath, downloader, extract


T                   = time.sleep
X                   = xbmc.executebuiltin
DIVIDE              = '[COLOR lime]-------------------------------------------------------------------------------------------------------[/COLOR]'
ADDON_ID            = 'plugin.program.droid.buddy'
ADDON               = xbmcaddon.Addon(id=ADDON_ID)
ADDONTITLE          = 'A1 MEDIA'
DIALOG              = xbmcgui.Dialog()
FANART3             = xbmc.translatePath(os.path.join('special://xbmc/addons/' + ADDON_ID , 'resources/art/fanart/fanart3.jpg'))
ART                 = xbmc.translatePath(os.path.join('special://home/addons/' + ADDON_ID + '/resources/art/android/'))
VERSION             = '0.0.7'
PATH                = 'A1 MEDIA'            
BASEURL             = 'http://'
HOME                = xbmc.translatePath('special://home/')
ADDONS              = os.path.join(HOME,     'addons')
PACKAGES            = os.path.join(ADDONS,   'packages')
KOBRA6              = '[COLOR dodgerblue][B]A1 MEDIA[/B][/COLOR]'
KOBRA7              = '[COLOR dodgerblue][B]A1 MEDIA Download Manager[/B][/COLOR]'
DOWNLOADPATH        = ADDON.getSetting('downloads')
ADULT               = ADDON.getSetting('adult')
DP                  = xbmcgui.DialogProgress()
ANDROIDAPKPATH      = os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads','Android Apks')
SET                 = '[COLOR black]You will need to set a downloads path before you can download any [/COLOR]'
INSTALL             = 'StartAndroidActivity("","android.intent.action.VIEW","application/vnd.android.package-archive","file:'
ERROR               = '[COLOR red]Error writing to download path!', 'Please select another download location and Check Path[/COLOR]'
YES                 = ' '
NO                  = ' '
ROMS_DIS			='A1	MEDIA does not host or upload any ROMs. A1 MEDIA is not responsible for the accuracy, compliance, copyright, legality, decency, or any other aspect of the content downloaded to your device. A1 MEDIA simply aggregates links to ROMs in a convenient, user-friendly interface. By downloading ANY files using A1 MEDIA you are agreeing to the rules mentioned: You own a licence for any ROM / image you download. You will NOT distribute any of these files illegally. You will NOT attempt to make any profit from any of these files. We can NOT be held responsible if users download files illegally. You acknowledge that all files linked are provided "as is" and we can NOT be held responsible if these files affect your system in any way. If you do not agree, please click NO.[CR][CR]THIS SOFTWARE IS BEING PROVIDED AS IT IS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTY.'



###############################
##### CHECK DOWNLOAD PATH #####
###############################

def CHECK_DOWNLOAD_PATH():
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH):
        if DIALOG.yesno(KOBRA7,' ','[COLOR black]You need to set a download path','Would you like to do this now?[/COLOR]','[COLOR orange]NO[/COLOR]','[COLOR dodgerblue]YES[/COLOR]'):
            SETTINGS(ADDON_ID, 0.0, True)
            MAIN_MENU()
        else: MAIN_MENU()
    else: MAIN_MENU()


	
#################
#### ANDROID ####
#################

### ANDROID MAIN MENU ###--------------------------------------------------------------------------------------------------------------------------------------

def ANDROID_MENU():
    addDir('[COLOR dodgerblue][B]ANDROID  MENU[/B][/COLOR]','noop',0,ART+'android3.png',FANART3,'')
    addDir('[COLOR dodgerblue]*******************[/COLOR]','noop',0,ART+'template.png',FANART3,'')
    # addDir('[COLOR dodgerblue]Install APKs[/COLOR]',BASEURL,18,ART+'installapks.png',FANART3,'')
    addDir('[COLOR dodgerblue]App Drawer[/COLOR]',BASEURL,19,ART+'appdrawer.png',FANART3,'')
    addDir('[COLOR dodgerblue]Roms[/COLOR]',BASEURL,45,ART+'roms3.png',FANART3,'')
    addDir('[COLOR dodgerblue]Requests[/COLOR]',BASEURL,13,ART+'requests.png',FANART3,'')
    addDir('[COLOR dodgerblue]Add-on Settings[/COLOR]',BASEURL,22,ART+'settings.png',FANART3,'')
    addDir('[COLOR dodgerblue]Download Manager[/COLOR]',BASEURL,36,ART+'downloads.png',FANART3,'')
    addDir('[COLOR dodgerblue]Change Download Location[/COLOR]',BASEURL,46,ART+'downloads.png',FANART3,'')
    addDir('[COLOR dodgerblue]Manage Android Apps[/COLOR]',BASEURL,47,ART+'downloads.png',FANART3,'')
    addDir('[COLOR dodgerblue]Clear Update Packages[/COLOR]',BASEURL,48,ART+'downloads.png',FANART3,'')
    addDir('[COLOR dodgerblue]Clear App Data[/COLOR]',BASEURL,49,ART+'downloads.png',FANART3,'')
    SET_VIEW('list', 'LIST')


	
### ANDROID MENU 1 ###-----------------------------------------------------------------------------------------------------------------------------------------

def ANDROID_MENU_1():
    # addDir('[COLOR dodgerblue][B]INSTALL  APKS[/B][/COLOR]','noop',18,ART+'installapks.png',FANART3,'')
    # addDir('[COLOR dodgerblue]*****************[/COLOR]','noop',18,ART+'template.png',FANART3,'')
    # addDir('[COLOR dodgerblue]Apps[/COLOR]',BASEURL,50,ART+'apps3.png',FANART3,'')
    # addDir('[COLOR dodgerblue]Emulators[/COLOR]',BASEURL,7,ART+'emulators3.png',FANART3,'')
    # addDir('[COLOR dodgerblue]Rom Packs[/COLOR]',BASEURL,61,ART+'emulators3.png',FANART3,'')
    # addDir('[COLOR dodgerblue]Sega Master System[/COLOR]',BASEURL,76,'http://dabutcher.org/DB/img/mastersystem.jpg',FANART3,'')
    # addDir('[COLOR dodgerblue]Sega Genesis/Megadrive[/COLOR]',BASEURL,62,'http://dabutcher.org/DB/img/genesis.png',FANART3,'')
    # addDir('[COLOR dodgerblue]Sega Mega CD[/COLOR]',BASEURL,66,'http://dabutcher.org/DB/img/sega-cd.png',FANART3,'')
    # addDir('[COLOR dodgerblue]Sega Dreamcast[/COLOR]',BASEURL,64,'http://dabutcher.org/DB/img/dreamcast.jpg',FANART3,'')
    # addDir('[COLOR dodgerblue]Sega Saturn[/COLOR]',BASEURL,68,'http://dabutcher.org/DB/img/segasaturn.png',FANART3,'') 
    # addDir('[COLOR dodgerblue]Super Nintendo Entertainment Sysyem (SNES)[/COLOR]',BASEURL,72,'http://dabutcher.org/DB/img/snes.jpg',FANART3,'')
    # addDir('[COLOR dodgerblue]Nintendo Gamecube[/COLOR]',BASEURL,70,'http://dabutcher.org/DB/img/gamecube.png',FANART3,'')
    # addDir('[COLOR dodgerblue]Nintendo GameBoy Advance[/COLOR]',BASEURL,78,'http://dabutcher.org/DB/img/20399436_B.jpg',FANART3,'')
    # addDir('[COLOR dodgerblue]Nintendo GameBoy Color[/COLOR]',BASEURL,80,'http://dabutcher.org/DB/img/gameboy_color.png',FANART3,'')
    # addDir('[COLOR dodgerblue]Nintendo GameBoy[/COLOR]',BASEURL,82,'http://dabutcher.org/DB/img/gameboy.png',FANART3,'')
    # addDir('[COLOR dodgerblue]Nintendo Entertainment Sysyem (NES)[/COLOR]',BASEURL,74,'http://dabutcher.org/DB/img/nes.jpg',FANART3,'')
    # if (getS('adult') == 'true'): addDir('[COLOR dodgerblue]Adult Apps[/COLOR]',BASEURL,9,ART+'adult3.png',FANART3,'')
    SET_VIEW('list', 'LIST')


 ### ANDROID MENU 2 ###-----------------------------------------------------------------------------------------------------------------------------------------

def ANDROID_MENU_2():
    # addDir('[COLOR dodgerblue][B]INSTALL  APKS[/B][/COLOR]','noop',18,ART+'installapks.png',FANART3,'')
    # addDir('[COLOR dodgerblue]*****************[/COLOR]','noop',18,ART+'template.png',FANART3,'')
    # addDir('[COLOR dodgerblue]Kids[/COLOR]',BASEURL,57,ART+' ',FANART3,'')
    # addDir('[COLOR dodgerblue]Movies and TV Shows[/COLOR]',BASEURL,55,ART+' ',FANART3,'')
    # addDir('[COLOR dodgerblue]Live TV and Sports[/COLOR]',BASEURL,54,ART+' ',FANART3,'')
    # addDir('[COLOR dodgerblue]Music[/COLOR]',BASEURL,53,ART+' ',FANART3,'')
    # addDir('[COLOR dodgerblue]Tools[/COLOR]',BASEURL,52,ART+' ',FANART3,'')
    # addDir('[COLOR dodgerblue]Kodi & SPMC[/COLOR]',BASEURL,51,ART+' ',FANART3,'')
    # addDir('[COLOR dodgerblue]Custom Kodi & SPMC[/COLOR]',BASEURL,60,ART+' ',FANART3,'')
    # addDir('[COLOR dodgerblue]Vpns[/COLOR]',BASEURL,59,ART+' ',FANART3,'')
    # addDir('[COLOR dodgerblue]Adult[/COLOR]',BASEURL,9,ART+' ',FANART3,'')
    SET_VIEW('list', 'LIST')


	
### MANAGE DOWNLOADS MENU ###-------------------------------------------------------------------------------------------------------------------------------

def MANAGE_DOWNLOADS_ANDROID():
    addDir('[COLOR dodgerblue][B]DOWNLOAD MANAGER[/B][/COLOR]','noop',0,ART+'downloads.png',FANART3,'')
    addDir('[COLOR dodgerblue]***************************[/COLOR]','noop',0,ART+'template.png',FANART3,'')
    addDir('[COLOR dodgerblue]My Downloads[/COLOR]',BASEURL,27,ART+'downloads.png',FANART3,'')
    addDir('[COLOR dodgerblue]Clean Downloads[/COLOR]',BASEURL,37,ART+'downloads.png',FANART3,'')


	
### APP DRAWER ###---------------------------------------------------------------------------------------------------------------------------------------------

def MY_APP_DRAWER():
    X('ActivateWindow(10001,androidapp://sources/apps/,return)')
    SET_VIEW('list', 'LIST')



### ACTIVATE HOME WINDOW ###---------------------------------------------------------------------------------------------------------------------------------------------

def HOME():
    X("XBMC.ActivateWindow(home,return)")



### ACTIVATE EMULATORS WINDOW ###--------------------------------------------------------------------------------------------------------------------------------------------

def ACTIVATE_EMULATORS_MENU():
    X("XBMC.ActivateWindow(10035,return)")



### ACTIVATE ROMs WINDOW ###--------------------------------------------------------------------------------------------------------------------------------------------

def ACTIVATE_ROMS_MENU():
    X("XBMC.ActivateWindow(1100,return)")



### ACTIVATE CATEGORIES WINDOW ###---------------------------------------------------------------------------------------------------------------------------------------------

def ACTIVATE_CATEGORIES_MENU():
    X("XBMC.ActivateWindow(shutdownmenu)")

	
	
### KIDS APPS WIZARD ###-----------------------------------------------------------------------------------------------------------------------------------------------

def KIDS_APPS_WIZARD():
    addDir('[COLOR black][B]Home Menu[/B][/COLOR]','url',44,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    link = OPEN_URL('http://www.a1media.live/server/A1%20MEDIA%20APP%20STORE/A1%20MEDIA/A1%20MEDIA.txt').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir('[COLOR=black]%s[/COLOR]' %name,url,5,iconimage,fanart,'[COLOR=black]%s[/COLOR]' %description)
    SET_VIEW('list', 'LIST')

	
	
### KODI SPMC APPS WIZARD ###-----------------------------------------------------------------------------------------------------------------------------------------------

def KODI_SPMC_APPS_WIZARD():
    addDir('[COLOR black][B]Home Menu[/B][/COLOR]','url',44,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    link = OPEN_URL('http://jaytech.tech/A1App_APK_Downloader/apk.downloader.apps.wizard.txt').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir('[COLOR=black]%s[/COLOR]' %name,url,5,iconimage,fanart,'[COLOR=black]%s[/COLOR]' %description)
    SET_VIEW('list', 'LIST')

	
	
### CUSTOM KODI SPMC APPS WIZARD ###-----------------------------------------------------------------------------------------------------------------------------------------------
	
def CUSTOM_KODI_SPMC_APPS_WIZARD():
    addDir('[COLOR black][B]Home Menu[/B][/COLOR]','url',44,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    link = OPEN_URL('http://www.a1media.live/server/A1%20MEDIA%20APP%20STORE/').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir('[COLOR=black]%s[/COLOR]' %name,url,5,iconimage,fanart,'[COLOR=black]%s[/COLOR]' %description)
    SET_VIEW('list', 'LIST')



### TOOLS APPS WIZARD ###-----------------------------------------------------------------------------------------------------------------------------------------------

def TOOLS_APPS_WIZARD():
    addDir('[COLOR black][B]Home Menu[/B][/COLOR]','url',44,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    link = OPEN_URL('http://www.a1media.live/server/A1%20MEDIA%20APP%20STORE/TOOLS/TOOLS.txt').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir('[COLOR=black]%s[/COLOR]' %name,url,5,iconimage,fanart,'[COLOR=black]%s[/COLOR]' %description)
    SET_VIEW('list', 'LIST')

	

### MUSIC APPS WIZARD ###-----------------------------------------------------------------------------------------------------------------------------------------------

def MUSIC_APPS_WIZARD():
    addDir('[COLOR black][B]Home Menu[/B][/COLOR]','url',44,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    link = OPEN_URL('http://www.a1media.live/server/A1%20MEDIA%20APP%20STORE/GOOGLE%20HOME/GOOGLE.txt').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir('[COLOR=black]%s[/COLOR]' %name,url,5,iconimage,fanart,'[COLOR=black]%s[/COLOR]' %description)
    SET_VIEW('list', 'LIST')


	
### VPN APPS WIZARD ###-----------------------------------------------------------------------------------------------------------------------------------------------

def VPN_APPS_WIZARD():
    addDir('[COLOR black][B]Home Menu[/B][/COLOR]','url',44,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    link = OPEN_URL('http://www.a1media.live/server/A1%20MEDIA%20APP%20STORE/OTHER/OTHER.txt').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir('[COLOR=black]%s[/COLOR]' %name,url,5,iconimage,fanart,'[COLOR=black]%s[/COLOR]' %description)
    SET_VIEW('list', 'LIST')	

	
	
### LIVE TV & SPORTS APPS WIZARD ###-----------------------------------------------------------------------------------------------------------------------------------------------

def LIVETV_SPORTS_APPS_WIZARD():
    addDir('[COLOR black][B]Home Menu[/B][/COLOR]','url',44,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    link = OPEN_URL('http://www.a1media.live/server/A1%20MEDIA%20APP%20STORE/LIVE%20TV/LIVE.txt').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir('[COLOR=black]%s[/COLOR]' %name,url,5,iconimage,fanart,'[COLOR=black]%s[/COLOR]' %description)
    SET_VIEW('list', 'LIST')



### MOVIES & TVSHOWS APPS WIZARD ###-----------------------------------------------------------------------------------------------------------------------------------------------

def MOVIES_TVSHOWS_APPS_WIZARD():
    addDir('[COLOR black][B]Home Menu[/B][/COLOR]','url',44,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    link = OPEN_URL('http://www.a1media.live/server/A1%20MEDIA%20APP%20STORE/MOVIES%20AND%20TV/MOVIES.txt').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir('[COLOR=black]%s[/COLOR]' %name,url,5,iconimage,fanart,'[COLOR=black]%s[/COLOR]' %description)
    SET_VIEW('list', 'LIST')

	
	
### ROM APPS WIZARD ###---------------------------------------------------------------------------------------------------------------------------------------- 

def ROM_APPS_WIZARD():
    addDir('[COLOR black][B]Back To Retro Menu[/B][/COLOR]','url',58,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    link = OPEN_URL('http://jaytech.tech/A1App_APK_Downloader/pics/GAMES.txt').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir('[COLOR=black]%s[/COLOR]' %name,url,5,iconimage,fanart,'[COLOR=black]%s[/COLOR]' %description)
    SET_VIEW('list', 'LIST')



### ADULT APPS WIZARD ###-----------------------------------------------------------------------------------------------------------------------------------------

def ADULT_APPS_WIZARD():
    if DIALOG.yesno('[COLOR red][B]Enter the adult section?[/B][/COLOR]','','[COLOR red][B]! WARNING ![/B][/COLOR][CR][CR][COLOR dodgerblue][B]Explicit adult material.[/COLOR][CR][CR][/B] You may download and view only if you are at least 18 years of age or at least the legal age in the jurisdiction you reside or from which you access this content. By clicking YES, you agree to the terms above and will enter into the adult section. Alternatively, click NO to return to the home menu.','',' ',' '):
        addDir('[COLOR black][B]Home Menu[/B][/COLOR]','url',44,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png','http://dabutcher.org/DB/img/adult_bg.jpg','')
        link = OPEN_URL('http://dabutcher.org/DB/adult_apps_wizard_droid_buddy.txt').replace('\n','').replace('\r','')
        match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
        for name,url,iconimage,fanart,description in match:
            addDir('[COLOR=black]%s[/COLOR]' %name,url,10,iconimage,fanart,'[COLOR=black]%s[/COLOR]' %description)
        SET_VIEW('list', 'LIST')
    else: X("XBMC.ActivateWindow(home)")
        


### EMULATOR WIZARD ###-------------------------------------------------------------------------------------------------------------------------------------------

def EMULATOR_WIZARD():
    addDir('[COLOR black][B]Back To Retro Menu[/B][/COLOR]','url',58,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    link = OPEN_URL('https://www.dropbox.com/s/k5ysfhlqwgaufnn/EMULATER.txt?dl=1').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir('[COLOR=black]%s[/COLOR]' % name,url,8,iconimage,fanart,'[COLOR=black]%s[/COLOR]' % description)
    SET_VIEW('list', 'LIST')


	
### ROM PACK WIZARD ###-------------------------------------------------------------------------------------------------------------------------------------------

def ROM_PACK_WIZARD():
    addDir('[COLOR black][B]Back To Retro Menu[/B][/COLOR]','url',3,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    link = OPEN_URL('http://dabutcher.org/DB/rom_packs_zips_droid_buddy.txt').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir('[COLOR=black]%s[/COLOR]' % name,url,3,iconimage,fanart,'[COLOR=black]%s[/COLOR]' % description)
    SET_VIEW('list', 'LIST')	

	
	
### APP INSTALL ###--------------------------------------------------------------------------------------------------------------------------------------------

def APP_INSTALL(name,url,description):
    if name.startswith("[COLOR"):
        basename = re.sub("\[COLOR=.+?\](.*)\[/COLOR\]", "\\1", name)
    else:
        basename = name
    if not DOWNLOADPATH: 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]APKs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[B]Download Application?[/B]','%s' % name,'', description, yeslabel=YES, nolabel=NO)
        # X("PlayMedia(special://home/media/waiting.mp3)")
        if yes:
            DP.create('Downloading APK')
            if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads')): 
                try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads'))
                except: DIALOG.ok(KOBRA7 ,ERROR); setS('downloads', ''); ADDON.openSettings(); return
            if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads','Android Apks')): 
                try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads','Android Apks'))
                except: DIALOG.ok(KOBRA7 ,ERROR, 'Failed to create: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA', 'Android Apks'));  return
            lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'Android Apks', basename+'.apk')
            downloader.download(url, lib, DP)
            DP.close()
            DIALOG.ok(' ','[COLOR dodgerblue]Download:[/COLOR] [COLOR black]Successful.[/COLOR]','','[COLOR dodgerblue]Click[/COLOR] [B][COLOR black]OK[/COLOR][/B] [COLOR dodgerblue]to install[/COLOR] ' + '[COLOR dodgerblue]%s[/COLOR]' % name + '')
            #][NT3L]I[G3NC][# 
            X(INSTALL+lib+'")')
            DP.close()
            time.sleep(4)
            DIALOG.ok(' ','[COLOR dodgerblue]Thanks for using [/COLOR][COLOR black]A1	MEDIA[/COLOR]','','[COLOR dodgerblue]Click [/COLOR][B][COLOR  black]OK[/COLOR][/B] [COLOR dodgerblue]to continue[/COLOR]')
            # X("PlayMedia(special://xbmc/media/laugh.mp3)")



### EMULATOR INSTALL ###---------------------------------------------------------------------------------------------------------------------------------------

def EMULATOR_INSTALL(name,url,description):
    if name.startswith("[COLOR"):
        basename = re.sub("\[COLOR=.+?\](.*)\[/COLOR\]", "\\1", name)
    else:
        basename = name
    if not DOWNLOADPATH: 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]APKs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download Emulator?[/COLOR]','%s' % name,'', description, yeslabel=YES, nolabel=NO)
        if yes:
            DP.create('[B]Downloading APK[/B]')
            if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads')): 
                try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads'))
                except: DIALOG.ok(KOBRA7 ,ERROR); setS('downloads', ''); ADDON.openSettings(); return
            if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads','Android Apks')): 
                try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads','Android Apks'))
                except: DIALOG.ok(KOBRA7 ,ERROR, 'Failed to create: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA', 'Android Apks'));  return
            lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'Android Apks', basename+'.apk')
            downloader.download(url, lib, DP)
            DP.close()
            DIALOG.ok(' ','[COLOR dodgerblue]Download:[/COLOR] [COLOR black]Successful.[/COLOR]','','[COLOR dodgerblue]Click[/COLOR] [B][COLOR black]OK[/COLOR][/B] [COLOR dodgerblue]to install[/COLOR] ' + '[COLOR dodgerblue]%s[/COLOR]' % name + '')
            #][NT3L]I[G3NC][# 
            X(INSTALL+lib+'")')
            DP.close()
            time.sleep(4)
            DIALOG.ok(' ','','[COLOR dodgerblue]Thanks for using [/COLOR][COLOR black]A1 MEDIA[/COLOR]','[COLOR dodgerblue]Click [/COLOR][B][COLOR  black]OK[/COLOR][/B] [COLOR dodgerblue]to continue[/COLOR]')



### ADULT APP INSTALL ###--------------------------------------------------------------------------------------------------------------------------------------

def ADULT_INSTALL(name,url,description):
    if name.startswith("[COLOR"):
        basename = re.sub("\[COLOR=.+?\](.*)\[/COLOR\]", "\\1", name)
    else:
        basename = name
    if not DOWNLOADPATH: 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]APKs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[B]Download Adult Application?[/B]','%s' % name,'', description, yeslabel=YES, nolabel=NO)
        if yes:
            DP.create('[B]Downloading APK[/B]')
            if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads')): 
                try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads'))
                except: DIALOG.ok(KOBRA7 ,ERROR); setS('downloads', ''); ADDON.openSettings(); return
            if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads','Android Apks')): 
                try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads','Android Apks'))
                except: DIALOG.ok(KOBRA7 ,ERROR, 'Failed to create: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA', 'Android Apks'));  return
            lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'Android Apks', basename+'.apk')
            downloader.download(url, lib, DP)
            DP.close()
            DIALOG.ok(' ','[COLOR dodgerblue]Download:[/COLOR] [COLOR black]Successful.[/COLOR]','','[COLOR dodgerblue]Click[/COLOR] [B][COLOR black]OK[/COLOR][/B] [COLOR dodgerblue]to install[/COLOR] ' + '[COLOR dodgerblue]%s[/COLOR]' % name + '')
            #][NT3L]I[G3NC][# 
            X(INSTALL+lib+'")')
            DP.close()
            time.sleep(4)
            DIALOG.ok(' ','','[COLOR dodgerblue]Thanks for using [/COLOR][COLOR black]A1	MEDIA[/COLOR]','[COLOR dodgerblue]Click [/COLOR][B][COLOR  black]OK[/COLOR][/B] [COLOR dodgerblue]to continue[/COLOR]')



### ROMS PACKS INSTALL ###--------------------------------------------------------------------------------------------------------------------------------------		
			
def ROM_PACKS_INSTALL(name,url,description):
    if name.startswith("[COLOR"):
        basename = re.sub("\[COLOR=.+?\](.*)\[/COLOR\]", "\\1", name)
    else:
        basename = name
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]Rom packs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR black]Download[/COLOR]','%s' % name,'', description, yeslabel=YES, nolabel=NO)
        if yes:
            DP.create('[B]Downloading Rom Pack[/B]')
            if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads')): 
                try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads'))
                except: DIALOG.ok(KOBRA7 ,ERROR); setS('downloads', ''); ADDON.openSettings(); return
            if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads','Rom Packs')): 
                try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads','Rom Packs'))
                except: DIALOG.ok(KOBRA7 ,ERROR, 'Failed to create: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA', 'Rom Packs'));  return
            lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'Rom Packs', basename+'.zip')
            downloader.download(url, lib, DP)
            T(2)
            DP.update(0,"[COLOR black]Download complete[/COLOR]", "")
            T(1)
            yes = DIALOG.yesno('[COLOR black]Would you like to extract the ROM pack?[/COLOR]','%s' % name,'', 'extract?', yeslabel=YES, nolabel=NO)
            if yes:
				DP.update(0,"","[COLOR black]Extracting rom pack[/COLOR]")
				ROM_PACKS_PATH      = os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROM Packs', 'NES ROMs')
				extract.all(lib,ROM_PACKS_PATH,DP)
				T(1)
				DP.close()
				try: os.remove(lib)
				except: pass
            DIALOG.ok("[COLOR lime][I]KOBRA[/I][/COLOR][COLOR black]  ROM PACK INSTALLER[/COLOR]", "[COLOR black][CR]Rom pack successfully downloaded. Click OK to continue[/COLOR]")
        else: pass


		
#########################
### SEGA GENESIS ROMS ###
#########################

def sega_genesis_roms():
    addDir('[COLOR black][B]Back To ROMs Menu[/B][/COLOR]','url',84,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    base_url = 'http://jaytech.tech/a1roms/Sega.Genesis/'
    link = OPEN_URL(base_url).replace('\n','').replace('\r','')

# Grab the whole section consisting of url and name, we can then split this up in python
    match = re.compile('href="(.+?)</a>').findall(link)
    for item in match:
# Make sure the item is a valid zip
        if '.zip' in item:
# Split the string at a specific point so we end up with 2 strings (url and name)
            url, name = item.split('">')
            url = base_url+url
            name = cleanup_name(base_url, url)
            addDir(name,url,63,'http://jaytech.tech/a1roms/img/segagenesis.png','http://jaytech.tech/a1roms/img/fanart3.png','')
    SET_VIEW('files', 'MAIN')
	

def sega_rom_download(name,url,description):
    if name.startswith("[COLOR"):
        basename = re.sub("\[COLOR=.+?\](.*)\[/COLOR\]", "\\1", name)
    else:
        basename = name
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]ROMs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download this ROM?[/COLOR]','%s' % name,'', ROMS_DIS, yeslabel=YES, nolabel=NO)
        if yes:
				DP.create("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]")
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Genesis-Megadrive_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Genesis-Megadrive_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]'); setS('downloads', ""); ADDON.openSettings(); return
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Genesis-Megadrive_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Genesis-Megadrive_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]', '[COLOR black]Failed to create[/COLOR]: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Genesis-Megadrive_ROMs'));  return
				lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Genesis-Megadrive_ROMs', name+'.zip')
				downloader.download(url, lib, DP)
				T(2)
				DP.close()
				DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]", "[COLOR black][CR]ROM successfully downloaded. Click OK to continue[/COLOR]")
        else: pass

		
###############################
### SEGA MASTER SYSTEM ROMS ###
###############################

def sega_mater_system_roms():
    addDir('[COLOR black][B]Back To ROMs Menu[/B][/COLOR]','url',84,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    base_url = 'http://jaytech.tech/a1roms/Sega.Master.System/'
    link = OPEN_URL(base_url).replace('\n','').replace('\r','')

# Grab the whole section consisting of url and name, we can then split this up in python
    match = re.compile('href="(.+?)</a>').findall(link)
    for item in match:
# Make sure the item is a valid zip
        if '.zip' in item:
# Split the string at a specific point so we end up with 2 strings (url and name)
            url, name = item.split('">')
            url = base_url+url
            name = cleanup_name(base_url, url)
            addDir(name,url,77,'http://jaytech.tech/a1roms/img/smspng.png','http://jaytech.tech/a1roms/img/fanart3.png','')
    SET_VIEW('files', 'MAIN')


def sega_mater_system_roms_rom_download(name,url,description):
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]ROMs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download this ROM?[/COLOR]','%s' % name,'', ROMS_DIS, yeslabel=YES, nolabel=NO)
        if yes:
				DP.create("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]")
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Master_System_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Master_System_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]'); setS('downloads', ""); ADDON.openSettings(); return
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Master_System_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Master_System_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]', '[COLOR black]Failed to create[/COLOR]: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Master_System_ROMs'));  return
				lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Master_System_ROMs', name+'.bin')
				downloader.download(url, lib, DP)
				T(2)
				DP.close()
				DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]", "[COLOR black][CR]ROM successfully downloaded. Click OK to continue[/COLOR]")
        else: pass		
		
		
		
#########################
### SEGA MEGA CD ROMS ###
#########################

def sega_mega_cd_roms():
    addDir('[COLOR black][B]Back To ROMs Menu[/B][/COLOR]','url',84,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    base_url = 'http://dabutcher.org/DB/sega-cd.txt'
    link = OPEN_URL(base_url).replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?ize="(.+?)"').findall(link)
    for name,url,size in match:
        addDir2(name,url,67,'http://dabutcher.org/DB/img/sega-cd.png','http://upload.wikimedia.org/wikipedia/commons/thumb/8/81/Sega-CD-Model2-Set.jpg/1280px-Sega-CD-Model2-Set.jpg','','ROM size = '+size)
    SET_VIEW('files', 'MAIN')

def sega_mega_cd_rom_download(name,url,size):
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]ROMs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download this ROM?[/COLOR]','%s' % name,'', ROMS_DIS, yeslabel=YES, nolabel=NO)
        if yes:
				DP.create("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]")
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Mega_CD ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Mega_CD ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader [/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]'); setS('downloads', ""); ADDON.openSettings(); return
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Mega_CD ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Mega_CD ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]', '[COLOR black]Failed to create[/COLOR]: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Mega_CD ROMs'));  return
				lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Mega_CD ROMs', name+'.zip')
				downloader.download(url, lib, DP)
				T(2)
				DP.close()
				DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]", "[COLOR black][CR]ROM successfully downloaded. Click OK to continue[/COLOR]")
        else: pass
		

		
###########################
### SEGA DREAMCAST ROMS ###
###########################

def sega_dreacast_roms():
    addDir('[COLOR black][B]Back To ROMs Menu[/B][/COLOR]','url',84,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    base_url = 'http://dabutcher.org/DB/dreamcast.txt'
    link = OPEN_URL(base_url).replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?ize="(.+?)"').findall(link)
    for name,url,size in match:
        addDir2(name,url,65,'http://dabutcher.org/DB/img/dreamcast.jpg','https://upload.wikimedia.org/wikipedia/commons/thumb/8/81/Dreamcast-Console-Set.jpg/1280px-Dreamcast-Console-Set.jpg','','ROM size = '+size)
    SET_VIEW('files', 'MAIN')

def sega_dreacast_rom_download(name,url,size):
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]ROMs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download this ROM?[/COLOR]','%s' % name,'', ROMS_DIS, yeslabel=YES, nolabel=NO)
        if yes:
				DP.create("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]")
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Dreamcast ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Dreamcast ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]'); setS('downloads', ""); ADDON.openSettings(); return
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Dreamcast ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Dreamcast ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]', '[COLOR black]Failed to create[/COLOR]: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Dreamcast ROMs'));  return
				lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Dreamcast ROMs', name+'.zip')
				downloader.download(url, lib, DP)
				T(2)
				DP.close()
				DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]", "[COLOR black][CR]ROM successfully downloaded. Click OK to continue[/COLOR]")
        else: pass



########################
### SEGA SATURN ROMS ###
########################

def sega_saturn_roms():
    addDir('[COLOR black][B]Back To ROMs Menu[/B][/COLOR]','url',84,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    base_url = 'http://dabutcher.org/DB/segasaturn.txt'
    link = OPEN_URL(base_url).replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?ize="(.+?)"').findall(link)
    for name,url,size in match:
        addDir2(name,url,69,'http://dabutcher.org/DB/img/segasaturn.png','http://dabutcher.org/DB/img/fanart3.png','','ROM size = '+size)
    SET_VIEW('files', 'MAIN')

def sega_saturn_rom_download(name,url,size):
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]ROMs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download this ROM?[/COLOR]','%s' % name,'', ROMS_DIS, yeslabel=YES, nolabel=NO)
        if yes:
				DP.create("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]")
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Saturn ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Saturn ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader [/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]'); setS('downloads', ""); ADDON.openSettings(); return
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Saturn ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Saturn ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]', '[COLOR black]Failed to create[/COLOR]: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Saturn ROMs'));  return
				lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Sega_Saturn ROMs', name+'.zip')
				downloader.download(url, lib, DP)
				T(2)
				DP.close()
				DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]", "[COLOR black][CR]ROM successfully downloaded. Click OK to continue[/COLOR]")
        else: pass



##############################
### NINTENDO GAMECUBE ROMS ###
##############################

def nintendo_gamecube_roms():
    addDir('[COLOR black][B]Back To ROMs Menu[/B][/COLOR]','url',84,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    base_url = 'http://dabutcher.org/DB/sega-cd.txt'
    link = OPEN_URL(base_url).replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?ize="(.+?)"').findall(link)
    for name,url,size in match:
        addDir2(name,url,71,'http://jaytech.tech/a1roms/img/mame.png','http://dabutcher.org/DB/img/fanart3.png','','ROM size = '+size)
    SET_VIEW('files', 'MAIN')

def nintendo_gamecube_rom_download(name,url,size):
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]ROMs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download this ROM?[/COLOR]','%s' % name,'', ROMS_DIS, yeslabel=YES, nolabel=NO)
        if yes:
				DP.create("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]")
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'MAME_2014_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'MAME_2014_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]'); setS('downloads', ""); ADDON.openSettings(); return
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'MAME_2014_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'MAME_2014_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]', '[COLOR black]Failed to create[/COLOR]: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'MAME_2014_ROMs'));  return
				lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'MAME_2014_ROMs', name+'.zip')
				downloader.download(url, lib, DP)
				T(2)
				DP.close()
				DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]", "[COLOR black][CR]ROM successfully downloaded. Click OK to continue[/COLOR]")
        else: pass



###########################
### SUPER NINTENDO ROMS ###
###########################

def super_nintendo_roms():
    addDir('[COLOR black][B]Back To ROMs Menu[/B][/COLOR]','url',84,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    base_url = 'http://jaytech.tech/a1roms/Super.Nintendo/'
    link = OPEN_URL(base_url).replace('\n','').replace('\r','')

# Grab the whole section consisting of url and name, we can then split this up in python
    match = re.compile('href="(.+?)</a>').findall(link)
    for item in match:
# Make sure the item is a valid zip
        if '.zip' in item:
# Split the string at a specific point so we end up with 2 strings (url and name)
            url, name = item.split('">')
            url = base_url+url
            name = cleanup_name(base_url, url)
            addDir(name,url,73,'http://jaytech.tech/a1roms/img/snes.png','http://jaytech.tech/a1roms/img/fanart3.png','')
    SET_VIEW('files', 'MAIN')

def super_nintendo_roms_download(name,url,size):
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]ROMs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download this ROM?[/COLOR]','%s' % name,'', ROMS_DIS, yeslabel=YES, nolabel=NO)
        if yes:
				DP.create("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]")
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Super_Nintendo(SNES)_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Super_Nintendo(SNES)_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]'); setS('downloads', ""); ADDON.openSettings(); return
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Super_Nintendo(SNES)_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Super_Nintendo(SNES)_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue)A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]', '[COLOR black]Failed to create[/COLOR]: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA -Downloads', 'ROMs', 'Super_Nintendo(SNES)_ROMs'));  return
				lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Super_Nintendo(SNES)_ROMs', name+'.zip')
				downloader.download(url, lib, DP)
				T(2)
				DP.close()
				DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]", "[COLOR black][CR]ROM successfully downloaded. Click OK to continue[/COLOR]")
        else: pass
	


#################
### NES ROMS  ###
#################

def nes_roms():
    addDir('[COLOR black][B]Back To ROMs Menu[/B][/COLOR]','url',84,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    base_url = 'http://jaytech.tech/a1roms/NES/'
    link = OPEN_URL(base_url).replace('\n','').replace('\r','')

# Grab the whole section consisting of url and name, we can then split this up in python
    match = re.compile('href="(.+?)</a>').findall(link)
    for item in match:
# Make sure the item is a valid zip
        if '.zip' in item:
# Split the string at a specific point so we end up with 2 strings (url and name)
            url, name = item.split('">')
            url = base_url+url
            name = cleanup_name(base_url, url)
            addDir(name,url,75,'http://jaytech.tech/a1roms/img/nes.png','http://jaytech.tech/a1roms/img/fanart3.png','')
    SET_VIEW('files', 'MAIN')	

def nes_roms_roms_download(name,url,size):
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]ROMs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download this ROM?[/COLOR]','%s' % name,'', ROMS_DIS, yeslabel=YES, nolabel=NO)
        if yes:
				DP.create("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]")
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Nintendo_Entertainment_System(NES)_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Nintendo_Entertainment_System(NES)_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]'); setS('downloads', ""); ADDON.openSettings(); return
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Nintendo_Entertainment_System(NES)_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Nintendo_Entertainment_System(NES)_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]', '[COLOR black]Failed to create[/COLOR]: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Nintendo_Entertainment_System(NES)_ROMs'));  return
				lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'Nintendo_Entertainment_System(NES)_ROMs', name+'.zip')
				downloader.download(url, lib, DP)
				T(2)
				DP.close()
				DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]", "[COLOR black][CR]ROM successfully downloaded. Click OK to continue[/COLOR]")
        else: pass
		


#######################
### GAMEBOY ADVANCE ###
#######################

def gameboy_advance_roms():
    addDir('[COLOR black][B]Back To ROMs Menu[/B][/COLOR]','url',84,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    base_url = 'http://jaytech.tech/a1roms/Gameboy.Advance/'
    link = OPEN_URL(base_url).replace('\n','').replace('\r','')

# Grab the whole section consisting of url and name, we can then split this up in python
    match = re.compile('href="(.+?)</a>').findall(link)
    for item in match:
# Make sure the item is a valid zip
        if '.zip' in item:
# Split the string at a specific point so we end up with 2 strings (url and name)
            url, name = item.split('">')
            url = base_url+url
            name = cleanup_name(base_url, url)
            addDir(name,url,79,'hhttp://jaytech.tech/a1roms/img/gba.png','http://jaytech.tech/a1roms/img/fanart3.png.png','')
    SET_VIEW('files', 'MAIN')	

def gameboy_advance_roms_download(name,url,size):
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]ROMs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download this ROM?[/COLOR]','%s' % name,'', ROMS_DIS, yeslabel=YES, nolabel=NO)
        if yes:
				DP.create("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]")
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Advance_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Advance_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]'); setS('downloads', ""); ADDON.openSettings(); return
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Advance_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Advance_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]', '[COLOR black]Failed to create[/COLOR]: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Advance_ROMs'));  return
				lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Advance_ROMs', name+'.zip')
				downloader.download(url, lib, DP)
				T(2)
				DP.close()
				DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]", "[COLOR black][CR]ROM successfully downloaded. Click OK to continue[/COLOR]")
        else: pass		

		

#####################
### GAMEBOY COLOR ###
#####################

def gameboy_colour_roms():
    addDir('[COLOR black][B]Back To ROMs Menu[/B][/COLOR]','url',84,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    base_url = 'http://jaytech.tech/a1roms/Gameboy.Color/'
    link = OPEN_URL(base_url).replace('\n','').replace('\r','')

# Grab the whole section consisting of url and name, we can then split this up in python
    match = re.compile('href="(.+?)</a>').findall(link)
    for item in match:
# Make sure the item is a valid zip
        if '.zip' in item:
# Split the string at a specific point so we end up with 2 strings (url and name)
            url, name = item.split('">')
            url = base_url+url
            name = cleanup_name(base_url, url)
            addDir(name,url,81,'http://jaytech.tech/a1roms/img/gbc.png','http://jaytech.tech/a1roms/img/fanart3.png','')
    SET_VIEW('files', 'MAIN')	

def gameboy_colour_roms_download(name,url,size):
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]ROMs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download this ROM?[/COLOR]','%s' % name,'', ROMS_DIS, yeslabel=YES, nolabel=NO)
        if yes:
				DP.create("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]")
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Color_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Color_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]'); setS('downloads', ""); ADDON.openSettings(); return
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Color_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Color_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]', '[COLOR black]Failed to create[/COLOR]: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Color_ROMs'));  return
				lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_Color_ROMs', name+'.zip')
				downloader.download(url, lib, DP)
				T(2)
				DP.close()
				DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]", "[COLOR black][CR]ROM successfully downloaded. Click OK to continue[/COLOR]")
        else: pass		


		
###############
### GAMEBOY ###
###############

def gameboy_roms():
    addDir('[COLOR black][B]Back To ROMs Menu[/B][/COLOR]','url',84,'http://jaytech.tech/A1App_APK_Downloader/pics/banner.png',FANART3,'')
    base_url = 'http://jaytech.tech/a1roms/Nintendo.Gameboy/'
    link = OPEN_URL(base_url).replace('\n','').replace('\r','')

# Grab the whole section consisting of url and name, we can then split this up in python
    match = re.compile('href="(.+?)</a>').findall(link)
    for item in match:
# Make sure the item is a valid zip
        if '.zip' in item:
# Split the string at a specific point so we end up with 2 strings (url and name)
            url, name = item.split('">')
            url = base_url+url
            name = cleanup_name(base_url, url)
            addDir(name,url,83,'http://jaytech.tech/a1roms/img/gameboy.png','http://jaytech.tech/a1roms/img/fanart3.png','')
    SET_VIEW('files', 'MAIN')	

def gameboy_roms_download(name,url,size):
    if DOWNLOADPATH == '' or not os.path.exists(DOWNLOADPATH): 
        DIALOG.ok(KOBRA7,' ', SET+'[COLOR black]ROMs[/COLOR]')
        SETTINGS(ADDON_ID, 0.1, True)
    else:
        yes = DIALOG.yesno('[COLOR dodgerblue]Download this ROM?[/COLOR]','%s' % name,'', ROMS_DIS, yeslabel=YES, nolabel=NO)
        if yes:
				DP.create("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]")
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]'); setS('downloads', ""); ADDON.openSettings(); return
				if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_ROMs')): 
					try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_ROMs'))
					except: DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]" '[COLOR red]Error writing to download path![/COLOR]', '[COLOR black]Please select another download location and Check Path[/COLOR]', '[COLOR black]Failed to create[/COLOR]: %s' % os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_ROMs'));  return
				lib=os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads', 'ROMs', 'GameBoy_ROMs', name+'.zip')
				downloader.download(url, lib, DP)
				T(2)
				DP.close()
				DIALOG.ok("[COLOR dodgerblue]A1 MEDIA ROM Downloader[/COLOR]", "[COLOR black][CR]ROM successfully downloaded. Click OK to continue[/COLOR]")
        else: pass			
		


### CLEAN UP NAME ###------------------------------------------------------------------------------------------------------------------------------------	

def cleanup_name(base_url, name):
    name = name.replace(base_url,'')
    name = urllib.unquote_plus(name)
    name = name.replace('.zip','')
    return name


	
### ANDROID COMING SOON ###------------------------------------------------------------------------------------------------------------------------------------

def COMING_SOON_ANDROID():
    addDir('[COLOR black]Coming soon...[/COLOR]','noop',0,ART+'comingsoon3.png',FANART3,'')
    SET_VIEW('list', 'LIST')


################################
###### CLEAN UP PACKAGES #######
##### THANKS GUYS @ XUNITY #####
##### MODDED BY AFTERMATH ######
###############################################################################################################################################################

### CLEAN UP ANDROID ###---------------------------------------------------------------------------------------------------------------------------------------

def CLEAN_UP_APKS():
    yes = DIALOG.yesno('[COLOR dodgerblue]Delete all download data?[/COLOR]','[COLOR black][CR][CR][COLOR red]WARNING![CR][CR][COLOR black]This will delete all of your download data.[CR][COLOR black][CR][COLOR red]WARNING![CR][CR][COLOR black][/COLOR]',yeslabel=YES, nolabel=NO)
    if yes:
        if os.path.exists(ANDROIDAPKPATH):
            try:
                for root, dirs, files in os.walk(ANDROIDAPKPATH):
                    file_count = 0
                    file_count += len(files)
                    # Count files and give option to delete
                    if file_count > 0:
                            for f in files: os.unlink(os.path.join(root, f))
                            for d in dirs: shutil.rmtree(os.path.join(root, d))
                            DIALOG.ok(' ','[COLOR dodgerblue]Delete download data: [COLOR black] Successful.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
                    else: DIALOG.ok(' ','[COLOR dodgerblue]Delete download data: [COLOR ffd33682]None found.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
            except: DIALOG.ok(' ','[COLOR dodgerblue]Delete download data: [COLOR red] Error.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
        else: DIALOG.ok(' ','[COLOR dodgerblue]Delete download data: [COLOR ffd33682] None found.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')

def DELETE_PACKAGES(url):
    packages_cache_path = xbmc.translatePath(os.path.join('special://home/addons/packages', ''))
    if os.path.exists(packages_cache_path):
        try:
            for root, dirs, files in os.walk(packages_cache_path):
                file_count = 0
                file_count += len(files)
                # Count files and give option to delete
                if file_count > 0:
                        for f in files: os.unlink(os.path.join(root, f))
                        for d in dirs: shutil.rmtree(os.path.join(root, d))
                        DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR black] Successful.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
                else: DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR ffd33682]None found.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
        except: DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR red] Error.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
    else: DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR ffd33682] None found.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')


def REFRESH(url):
    packages_cache_path = xbmc.translatePath(os.path.join('special://home/temp', ''))
    if os.path.exists(packages_cache_path):
        try:
            for root, dirs, files in os.walk(packages_cache_path):
                file_count = 0
                file_count += len(files)
                # Count files and give option to delete
                if file_count > 0:
                        for f in files: os.unlink(os.path.join(root, f))
                        for d in dirs: shutil.rmtree(os.path.join(root, d))
                        DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR black] Successful.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
                else: DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR ffd33682]None found.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
        except: DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR red] Error.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
    else: DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR ffd33682] None found.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
    REFRESH1(url)

def REFRESH1(url):
    packages_cache_path = xbmc.translatePath(os.path.join('special://home/cache/temp', ''))
    if os.path.exists(packages_cache_path):
        try:
            for root, dirs, files in os.walk(packages_cache_path):
                file_count = 0
                file_count += len(files)
                # Count files and give option to delete
                if file_count > 0:
                        for f in files: os.unlink(os.path.join(root, f))
                        for d in dirs: shutil.rmtree(os.path.join(root, d))
                        DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR black] Successful.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
                else: DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR ffd33682]None found.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
        except: DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR red] Error.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
    else: DIALOG.ok(' ','[COLOR dodgerblue]Clean update packages: [COLOR ffd33682] None found.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
    
def CLEAR_APP_DATA():
    yes = DIALOG.yesno('[COLOR dodgerblue]Clear A1 MEDIA data?[/COLOR]','[COLOR black][CR][CR][COLOR red]WARNING![CR][CR][COLOR black]This will delete all A1 MEDIA application data and restore to default settings.[COLOR black][CR][CR][COLOR red]WARNING![CR][CR][COLOR black][/COLOR]',yeslabel=YES, nolabel=NO)
    clear_data = xbmc.translatePath(os.path.join('special://home/userdata', ''))
    if yes:
        if os.path.exists(clear_data):
            try:
                for root, dirs, files in os.walk(clear_data):
                    file_count = 0
                    file_count += len(files)
                    # Count files and give option to delete
                    if file_count > 0:
                            for f in files: os.unlink(os.path.join(root, f))
                            for d in dirs: shutil.rmtree(os.path.join(root, d))
                            DIALOG.ok(' ','[COLOR dodgerblue]Clear App Data: [COLOR black] Successful.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to close [/COLOR][COLOR black]A1	MEDIA.[/COLOR]')
                            os._exit(1)
                    else: DIALOG.ok(' ','[COLOR dodgerblue]Clear App Data: [COLOR ffd33682]None found.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
            except: DIALOG.ok(' ','[COLOR dodgerblue]Clear App Data: [COLOR red] Error.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')
        else: DIALOG.ok(' ','[COLOR dodgerblue]Clear App Data: [COLOR ffd33682] None found.[/COLOR]',' ','[COLOR dodgerblue]Click [B][COLOR black]OK[/B] [COLOR dodgerblue]to continue.[/COLOR]')


################
### REQUESTS ###
###############################################################################################################################################################

def REQUESTS():
    TEXT_BOXES('','[CR][CR]Website: [COLOR dodgerblue]http://WWW.IPTVFROG.COM[/COLOR][CR]Website: [COLOR dodgerblue]http://WWW.METVSOLUTIONS.COM[/COLOR][CR][CR]JAYTECH YOUTUBE CHANNEL: [COLOR red]http://www.youtube.com[/COLOR][CR]MURDOC YOUTUBE CHANNEL: [COLOR red]http://www.youtube.com[/COLOR][CR][CR]FaceBook: [COLOR dodgerblue]A1 MEDIA[/COLOR][CR][CR]Big thanks to JAYTECH: [COLOR dodgerblue]https://WWW.COMINGSOON.ORG[/COLOR][CR]Big thanks to The ROBERT: [COLOR dodgerblue]http://WWW.GHOSTWARE.ORG[/COLOR]')
    #xbmc.executebuiltin('Notification(Happy Halloween!,10000,http://vignette3.wikia.nocookie.net/clubpenguin/images/0/0a/Pumpkin_Head_clothing_icon_ID_1095.png)')


##################
### TEXT BOXES ###
###############################################################################################################################################################

def TEXT_BOXES(heading,announce):
    class TextBox():
        WINDOW=10147
        CONTROL_LABEL=1
        CONTROL_TEXTBOX=5
        def __init__(self,*args,**kwargs):
            X('ActivateWindow(%d)' % (self.WINDOW, )) # activate the text viewer window
            self.win=xbmcgui.Window(self.WINDOW) # get window
            xbmc.sleep(500) # give window time to initialize
            self.setControls()
        def setControls(self):
            self.win.getControl(self.CONTROL_LABEL).setLabel(heading) # set heading
            try: f=open(announce); text=f.read()
            except: text=announce
            self.win.getControl(self.CONTROL_TEXTBOX).setText(str(text))
            return
    TextBox()

  
################
### SETTINGS ###
###############################################################################################################################################################

def SETTINGS(id=ADDON_ID, focus=None, click=False):
    try:
        X('Addon.OpenSettings(%s)' % id)
        value1, value2 = str(focus).split('.')
        X('SetFocus(%d)' % (int(value1) + 100))
        X('SetFocus(%d)' % (int(value2) + 200))
        if click == True: X('SendClick(%s)' % (int(value2) + 200))
    except:
        return
        
def getS(name):
    try: return ADDON.getSetting(name)
    except: return False

def setS(name, value):
    try: ADDON.setSetting(name, value)
    except: return False

def MANAGE_ANDROID_APPS():
    xbmc.executebuiltin('StartAndroidActivity("","android.intent.action.APPLICATION_DETAILS_SETTINGS")')
#StartAndroidActivity("","android.intent.action.VIEW","application/vnd.android.package-archive","file:'
    
def OPEN_DOWNLOAD_SETTINGS():
    SETTINGS(ADDON_ID, 0.1, True)

################
### OPEN URL ###
###############################################################################################################################################################

def OPEN_URL(url):
    req = urllib2.Request(url)
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
    response = urllib2.urlopen(req)
    link=response.read()
    response.close()
    return link


######################
### PARAMETER SHIT ###
###############################################################################################################################################################
 
def GET_PARAMS():
    param=[]
    paramstring=sys.argv[2]
    if len(paramstring)>=2:
        params=sys.argv[2]
        cleanedparams=params.replace('?','')
        if (params[len(params)-1]=='/'):
            params=params[0:len(params)-2]
        pairsofparams=cleanedparams.split('&')
        param={}
        for i in range(len(pairsofparams)):
            splitparams={}
            splitparams=pairsofparams[i].split('=')
            if (len(splitparams))==2:
                param[splitparams[0]]=splitparams[1]
    return param


#####################
### ADD DIRECTORY ###
###############################################################################################################################################################

def addDir(name,url,mode,iconimage,fanart,description):
        u=sys.argv[0]+'?url='+urllib.quote_plus(url)+'&mode='+str(mode)+'&name='+urllib.quote_plus(name)+'&iconimage='+urllib.quote_plus(iconimage)+'&fanart='+urllib.quote_plus(fanart)+'&description='+urllib.quote_plus(description)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage='DefaultFolder.png', thumbnailImage=iconimage)
        liz.setInfo( type='Video', infoLabels={ 'Title': name, 'Plot': description } )
        liz.setProperty( 'Fanart_Image', fanart )
        if  mode==3 or mode==5 or mode==8  or mode==10 or mode==11 or mode==13 or mode==17 or mode==19 or mode ==22 or mode==23 or mode==25 or mode==27 or mode==35 or mode==37 or mode==38 or mode==44 or mode==46 or mode==47 or mode==48 or mode==49 or mode==56 or mode==58 or mode==63 or mode==71 or mode==69 or mode==73 or mode==75 or mode==77 or mode==79 or mode==81 or mode==83 or mode==84 or url=='noop':
            ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        else:
            ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
        return ok
		
def addDir2(name,url,mode,iconimage,fanart,description,size):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)+"&fanart="+urllib.quote_plus(fanart)+"&description="+urllib.quote_plus(description)+"&size="+urllib.quote_plus(size)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name, "Plot": description } )
        liz.setProperty( "Fanart_Image", fanart )
        if  mode==65 or mode==67 or mode==71 or url=='noop':
            ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        else:
            ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
        return ok

#################
### DOWNLOADS ###
###############################################################################################################################################################     

def DOWNLOADS():
    if not DOWNLOADPATH: 
        DIALOG.ok(KOBRA7, '[COLOR black]Storage location for downloads does not exist.','','Click [B]OK[/B] to manage storage location. [/COLOR]')
        SETTINGS(ADDON_ID, 0.4, True)
    else:
        if not os.path.exists(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads')): 
                try: os.makedirs(os.path.join(DOWNLOADPATH, 'A1 MEDIA-Downloads'))
                except: DIALOG.ok(KOBRA6, '[COLOR red]Error writing to download path!', 'Please select another download location and Check Path[/COLOR]'); setS('downloads', ''); ADDON.openSettings(); return          
        if ANDROID :X('StartAndroidActivity("com.android.documentsui","android.intent.action.VIEW","*/*","file:'+ANDROIDAPKPATH+'")')


'''if xbmc.getCondVisibility("System.Platform.Android"):    X('StartAndroidActivity("com.android.documentsui","android.intent.action.VIEW","*/*","file:'+ANDROIDAPKPATH+'")')'''


  
###############################################################################################################################################################
                      
params=GET_PARAMS()
url         =None
name        =None
mode        =None
iconimage   =None
fanart      =None
description =None
size        = None

###############################################################################################################################################################

try: 		url=urllib.unquote_plus(params['url'])
except: 	pass
try: 		name=urllib.unquote_plus(params['name'])
except: 	pass
try: 		iconimage=urllib.unquote_plus(params['iconimage'])
except: 	pass
try: 		mode=int(params['mode'])
except:	 	pass
try: 		fanart=urllib.unquote_plus(params['fanart'])
except: 	pass
try: 		description=urllib.unquote_plus(params['description'])
except: 	pass
        
###############################################################################################################################################################
        
print str(PATH)+': '+str(VERSION)
print 'Mode: '+str(mode)
print 'URL: '+str(url)
print 'Name: '+str(name)
print 'IconImage: '+str(iconimage)

###############################################################################################################################################################

#################
### SET VIEWS ###
###############################################################################################################################################################

def SET_VIEW(content, viewType):
    if content:
        xbmcplugin.setContent(int(sys.argv[1]), content)
    if ADDON.getSetting('auto-view')=='true':
        X('Container.SetViewMode(%s)' % ADDON.getSetting(viewType) )

###############################################################################################################################################################

if mode==None or url==None or len(url)<1:
    ANDROID_MENU()

elif mode==2:       ANDROID_MENU()
elif mode==3: 		ROM_PACKS_INSTALL(name,url,description)
elif mode==5:       APP_INSTALL(name,url,description)
elif mode==7:       EMULATOR_WIZARD()
elif mode==8:       EMULATOR_INSTALL(name,url,description)
elif mode==9:       ADULT_APPS_WIZARD()
elif mode==10:      ADULT_INSTALL(name,url,description)
elif mode==13:      REQUESTS()
elif mode==18:      ANDROID_MENU_1()
elif mode==19:      MY_APP_DRAWER()
elif mode==20:      MAIN_MENU()
elif mode==22:      SETTINGS()
elif mode==27:      DOWNLOADS()
elif mode==36:      MANAGE_DOWNLOADS_ANDROID()
elif mode==37:      CLEAN_UP_APKS()
elif mode==38:      ANDROID_APK_DOWNLOAD(name,url,description)
elif mode==44:      HOME()
elif mode==45:      ROM_APPS_WIZARD()
elif mode==46:      OPEN_DOWNLOAD_SETTINGS()
elif mode==47:      MANAGE_ANDROID_APPS()
elif mode==48:      DELETE_PACKAGES(url)
elif mode==49:      CLEAR_APP_DATA()
elif mode==50:      ANDROID_MENU_2()
elif mode==51:      KODI_SPMC_APPS_WIZARD()
elif mode==52:      TOOLS_APPS_WIZARD()
elif mode==53:      MUSIC_APPS_WIZARD()
elif mode==54:      LIVETV_SPORTS_APPS_WIZARD()
elif mode==55:      MOVIES_TVSHOWS_APPS_WIZARD()
elif mode==56:      ACTIVATE_CATEGORIES_MENU()
elif mode==57:      KIDS_APPS_WIZARD()
elif mode==58:      ACTIVATE_EMULATORS_MENU()
elif mode==59:		VPN_APPS_WIZARD()
elif mode==60:		CUSTOM_KODI_SPMC_APPS_WIZARD()
elif mode==61:		ROM_PACK_WIZARD()
elif mode==62:		sega_genesis_roms()
elif mode==63:		sega_rom_download(name,url,description)
elif mode==64:		sega_dreacast_roms()
elif mode==65:		sega_dreacast_rom_download(name,url,size)
elif mode==66:		sega_mega_cd_roms()
elif mode==67:		sega_mega_cd_rom_download(name,url,size)
elif mode==68:		sega_saturn_roms()
elif mode==69:		sega_saturn_rom_download(name,url,size)
elif mode==70:		nintendo_gamecube_roms()
elif mode==71:		nintendo_gamecube_rom_download(name,url,size)
elif mode==72:		super_nintendo_roms()
elif mode==73:		super_nintendo_roms_download(name,url,size)
elif mode==74:		nes_roms()
elif mode==75:		nes_roms_roms_download(name,url,size)
elif mode==76:		sega_mater_system_roms()
elif mode==77:		sega_mater_system_roms_rom_download(name,url,description)
elif mode==78:		gameboy_advance_roms()
elif mode==79:		gameboy_advance_roms_download(name,url,size)
elif mode==80:		gameboy_colour_roms()
elif mode==81:		gameboy_colour_roms_download(name,url,size)
elif mode==82:		gameboy_roms()
elif mode==83:		gameboy_roms_download(name,url,size)
elif mode==84:		ACTIVATE_ROMS_MENU()
elif mode==99:      COMING_SOON_ANDROID()


############################################################################################################################################################### 
### POSSIBLE FUTURE UPDATES ###################################################################################################################################
###############################################################################################################################################################
    
###############################################################################################################################################################
xbmcplugin.endOfDirectory(int(sys.argv[1]))